
#pragma implementation "lg/interface.h"
#pragma implementation "lg/types.h"
#pragma implementation "lg/scrmsgs.h"
#pragma implementation "lg/links.h"

#include <math.h>

#include "lg/objstd.h"
#include "lg/interface.h"
#include "lg/types.h"
#include "lg/scrmsgs.h"
#include "lg/links.h"

extern IMalloc* g_pMalloc;

////////////
// cAnsiStr
////////////
/*
	cAnsiStr::cAnsiStr(int);
cAnsiStr::cAnsiStr(const char *);
cAnsiStr::cAnsiStr(const char *, int);
cAnsiStr::cAnsiStr(const cAnsiStr &);
cAnsiStr::cAnsiStr();
cAnsiStr::~cAnsiStr();
void cAnsiStr::FreeStr(char*);
void cAnsiStr::FmtStr(unsigned int, const char*, ...);
void cAnsiStr::FmtStr(const char*, ...);
int cAnsiStr::Insert(const char *, int);
void cAnsiStr::Remove(int, int);
void cAnsiStr::Append(int, const char *);
void cAnsiStr::BufDone(int, int);
void cAnsiStr::Attach(char*, int, int);
int cAnsiStr::SpanIncluding(const char*, int) const;
int cAnsiStr::SpanExcluding(const char*, int) const;
char* cAnsiStr::ReallocStr(char* int);
void cAnsiStr::Trim(void);
void cAnsiStr::Assign(int, const char *);
void cAnsiStr::ReleaseBuffer(void);
void cAnsiStr::DoGrowBuffer(int);
char* cAnsiStr::AllocStr(int);
char* cAnsiStr::Detach(void);
void cAnsiStr::Empty(void);
void cAnsiStr::ConcatCopy(int, const char*, int, const char*);
char* cAnsiStr::GetBuffer(int);
int cAnsiStr::Find(const char *, int);
int cAnsiStr::Find(char, int);
void cAnsiStr::AllocBuffer(int);
*/

///////////
// cScrVec
///////////
float cScrVec::Magnitude() const
{
	return sqrt((pos.x*pos.x) + (pos.y*pos.y) + (pos.z*pos.z));
}
float cScrVec::MagSquared() const
{
	return (pos.x*pos.x) + (pos.y*pos.y) + (pos.z*pos.z);
}

///////////////
// sScrMsgBase
///////////////
HRESULT __stdcall sScrMsgBase::QueryInterface(REFIID riid, void** ppv)
{
	if (riid == IID_IUnknown)
		*ppv = (IUnknown*)this;
	else {
		*ppv = NULL;
		return E_NOINTERFACE;
	}
	return S_OK;
}
ULONG __stdcall sScrMsgBase::AddRef()
{
	return ++m_iRef;
}
ULONG __stdcall sScrMsgBase::Release()
{
	if (--m_iRef == 0)
		delete this;
	return m_iRef;
}

///////////
// sScrMsg
///////////
sScrMsg::~sScrMsg()
{
	if (data.type == kMT_String || data.type == kMT_Vector)
		g_pMalloc->Free(data.psz);
	if (data2.type == kMT_String || data2.type == kMT_Vector)
		g_pMalloc->Free(data.psz);
	if (data3.type == kMT_String || data3.type == kMT_Vector)
		g_pMalloc->Free(data.psz);
}
